<?php
//-----------------------------------------------------------------------------
/*
Plugin Name: Author Spotlight (Widget)
Version: 1.0
Plugin URI: http://nullpointer.debashish.com
Description: Sidebar widget to display author profile on a post page.
Author: Debashish Chakrabarty
Author URI: http://www.debashish.com
Min WP Version: 2.7
*/
//-----------------------------------------------------------------------------
?>
<?php
	// the sidebar widget
	function authorprofile_widget( $args ) {
		global $authordata;
		extract( $args ); // extract arguments

		if(is_single()){
			$author_posts_link = get_author_posts_url($authordata->ID, $authordata->user_nicename );
			$options = get_option('authorprofile_widget'); // get options    
			echo $before_widget;
			echo $before_title . $options['title'] . $after_title;
			echo '<h4 id="author_name">'.get_the_author_firstname().' '.get_the_author_lastname().'</h4>';
			echo '<b>'. $options['websitetext'] . '</b> <a target="_blank" title="'.get_the_author_url().'" href="'.get_the_author_url().'">'.get_the_author_url().'</a><br/>';
			if(userphoto_exists($authordata))
				userphoto_thumbnail($authordata);
			else
				echo get_avatar($authordata->ID, 96);		
			echo '<div id="author_profile">'.snippet(get_the_author_description(),$options['charlimit'],'...').'<i><a href="'.$author_posts_link.'" title="Read full Profile">'.$options['readfulltext'].'</a></i></div>';
			
			echo '<div id="author_posts_link"><a href="'.$author_posts_link.'" title="More articles by this author">'.$options['moretext'].'</a></div>';
			echo $after_widget;  
		}

		// output done
		return;  
	}

function authorprofile_widget_control() {
	$options = $newoptions = get_option('authorprofile_widget'); // get options
  
	// set new options
	if( $_POST['authorprofile-widget-submit'] ) {
		$newoptions['title'] = strip_tags( stripslashes($_POST['authorprofile-widget-title']) );		
		$newoptions['readfulltext'] = strip_tags( stripslashes($_POST['authorprofile-readfull-text']) );
		$newoptions['moretext'] = strip_tags( stripslashes($_POST['authorprofile-moreposts-text']) );
		$newoptions['websitetext'] = strip_tags( stripslashes($_POST['authorprofile-website-text']) );
		$newoptions['charlimit'] = strip_tags( stripslashes($_POST['authorprofile-char-limit']) );
	}
  
	// update options if needed
	if( $options != $newoptions ) {
		$options = $newoptions;
		update_option('authorprofile_widget', $options);
	}
  
	// output  
	echo '<p>'._e('Title');
    echo '<input type="text" style="width:250px" id="authorprofile-widget-title" name="authorprofile-widget-title" value="'.attribute_escape($options['title']).'" />';
	echo '</p>';  
	echo '<p>'._e('"<i>Website</i>" text');
	echo '<input type="text" style="width:250px" id="authorprofile-website-text" name="authorprofile-website-text" value="'.attribute_escape($options['websitetext']).'" />';
	echo '</p>'; 
	echo '<p>'._e('<i>"More articles by author"</i> text');
    echo '<input type="text" style="width:250px" id="authorprofile-moreposts-text" name="authorprofile-moreposts-text" value="'.attribute_escape($options['moretext']).'" />';
	echo '</p>';
	echo '<p>'._e('Author profile charater limit');
    echo '<input type="text" style="width:250px" id="authorprofile-char-limit" name="authorprofile-char-limit" value="'.attribute_escape($options['charlimit']).'" />';
	echo '</p>';
	echo '<p>'._e('<i>"Read full profile"</i> text');
    echo '<input type="text" style="width:250px" id="authorprofile-readfull-text" name="authorprofile-readfull-text" value="'.attribute_escape($options['readfulltext']).'" />';
	echo '</p>';
	
	echo '<input type="hidden" name="authorprofile-widget-submit" id="authorprofile-widget-submit" value="1" />';
}

// activate and deactivate plugin
function authorprofile_activate() {
  // options, defaultvalues
  $options = array( 
    'widget' => array( 
      'title' => 'Author Spotlight',
	  'moretext' => 'More posts by the Author &raquo;',
	  'readfulltext' => 'Read Full',
	  'websitetext' => 'Website: ',
	  'charlimit' => 1000
    )
  );
  
  // register option
  add_option( 'authorprofile_widget', $options['widget'] );  
  // activated
  return;
}

function authorprofile_deactivate() {
  // unregister option
  delete_option('authorprofile_widget');   
  // deactivated
  return;
}

// initialization
function authorprofile_init() {  
  // register widget
  $class['classname'] = 'authorprofile_widget';
  wp_register_sidebar_widget('post_author_profile', __('Author Spotlight'), 'authorprofile_widget', $class);
  wp_register_widget_control('post_author_profile', __('Author Spotlight'), 'authorprofile_widget_control', 'width=200&height=200');
  
  // initialization done
  return;  
}

function snippet($text, $length=1000, $tail="...") {
	$text = trim($text);
	$txtl = strlen($text);
	if($txtl > $length) {
		for($i=1;$text[$length-$i]!=" ";$i++) {
			if($i == $length) {
				return substr($text,0,$length) . $tail;
			}
		}
		$text = substr($text,0,$length-$i+1) . $tail;
	}
	return $text;
}

// actions
add_action( 'activate_'.plugin_basename(__FILE__),   'authorprofile_activate' );
add_action( 'deactivate_'.plugin_basename(__FILE__), 'authorprofile_deactivate' );
add_action( 'init', 'authorprofile_init');
?>